#include <stdio.h>

#include <lq.h>

void cb(lq_stats *s)
{
	printf("%4x:%-4x rate=%u ceil=%u parent=%4x:%4x bytes=%llu packets=%u drops=%u overlimits=%u bps=%u pps=%u qlen=%u backlog=%u\n",
		s->handle >> 16, s->handle & 0xffff,
		s->rate, s->ceil,
		s->parent >> 16, s->parent & 0xffff,
		s->bytes, s->packets, s->drops, s->overlimits, s->bps, 
		s->pps, s->qlen, s->backlog);
}

int main(void)
{
	int	dummy0;
	int	ret;

	lq_debug = 0;

	ret = lq_init();
	if (ret == -1) {
		printf("Cannot init lq [%s]\n",
			lq_strerror());
		return 1;
	}

	dummy0 = lq_getif("dummy0");
	if (dummy0 == -1) {
		printf("Error geting info about dummy [%s]!\n",
			lq_strerror());
		return 1;
	}

	ret = lq_getstats(LQ_class, dummy0, cb);
	if (ret == -1) {
		printf("Error getting stats [%s]!\n",
			lq_strerror());
		return 1;
	}

	return 0;
}
