#include <stdio.h>

#include <lqapi.h>

int main (void)
{
	int	dummy0;
	int	ret;
	lqapi	O;


	ret = lqapi_init ();
	if (ret == -1) {
		printf ("Cannot init lqapi [%s]\n",
			lqapi_strerror ());
		return 1;
	}

	dummy0 = lqapi_getif ("dummy0");
	if (dummy0 == -1) {
		printf ("Error geting info about dummy [%s]!\n",
			lqapi_strerror ());
		return 1;
	}

	printf ("######################################\n");
	O.type = LQapi_filter;
	O.subtype = LQapi_f_fw;
	lqapi_set (&O);

	O.id = 0x1234;
	O.parent = 0x00010000; /* qdisc 1: */
	O.ifindex = dummy0;

	O.data.f.prio = 10;
	O.data.f.classid = 0x00010002;	/* class 1:2 */

	ret = lqapi_do (LQapi_add, &O);
	if (ret == -1) {
		printf ("Error adding filter to dummy0 [%s]:\n%s\n",
			lqapi_strerror (), lqapi_dump (&O));
		return 1;
	}

	return 0;
}
