#include <stdio.h>

#include <lq.h>

void doit(unsigned short op, lq *O)
{
	int	ret;

	ret = lq_do(op, O);
	if (ret == -1) {
		printf("Error adding object [%s]:\n%s\n",
			lq_strerror(), lq_dump(O));
		exit(1);
	}
}

int main (void)
{
	int	dummy0, ret;
	lq	O;


	ret = lq_init();
	if (ret == -1) {
		printf("Cannot init lq [%s]\n",
			lq_strerror());
		return 1;
	}

	dummy0 = lq_getif("dummy0");
	if (dummy0 == -1) {
		printf("Error geting info about dummy [%s]!\n",
			lq_strerror());
		return 1;
	}

	/* ########################### Add root qdisc ############################### */
	O.type = LQ_qdisc;
	O.subtype = LQ_q_htb;
	lq_set(&O);

	O.id = 0x20000;
	O.ifindex = dummy0;

	O.data.q.htb.glob.defcls = 0x9999;

	doit(LQ_add, &O);

	/* ########################### Add default ################################## */
	O.type = LQ_class;
	O.subtype = LQ_c_htb;
	lq_set(&O);

	O.parent = 0x20000;
	O.id = 0x29999;
	O.ifindex = dummy0;

	O.data.c.htb.opt.prio = 2;
	O.data.c.htb.opt.rate.rate = 1000;
	O.data.c.htb.opt.ceil.rate = 2000;

	doit(LQ_add, &O);

	return 0;
}
