#include <stdio.h>

#include <lq.h>

int main (void)
{
	int	dummy0;
	int	ret;
	lq	O;

	ret = lq_init();
	if (ret == -1) {
		printf("Cannot init lq [%s]\n",
			lq_strerror());
		return 1;
	}

	dummy0 = lq_getif("dummy0");
	if (dummy0 == -1) {
		printf("Error geting info about dummy [%s]!\n",
			lq_strerror());
		return 1;
	}

	printf ("######################################\n");

	O.type = LQ_qdisc;
	O.subtype = LQ_q_prio;
	lq_set(&O);

	O.id = 0x20000;
	O.ifindex = dummy0;

	O.data.q.prio.opt.bands = 5;
	O.data.q.prio.opt.priomap[0] = 4;
	O.data.q.prio.opt.priomap[1] = 3;
	O.data.q.prio.opt.priomap[2] = 2;
	O.data.q.prio.opt.priomap[3] = 1;
	O.data.q.prio.opt.priomap[4] = 0;

	ret = lq_do(LQ_add, &O);
	if (ret == -1) {
		printf("Error adding sfq to dummy0 [%s]:\n%s\n",
			lq_strerror(), lq_dump(&O));
		return 1;
	}

	return 0;
}
