#include <stdio.h>

#include <lq.h>

int main (void)
{
	int dummy0;
	int ret;
	lq O;

	ret = lq_init();
	if (ret == -1) {
		printf("Cannot init lq [%s]\n",
			lq_strerror());
		return 1;
	}

	dummy0 = lq_getif("dummy0");
	if (dummy0 == -1) {
		printf("Error geting info about dummy [%s]!\n",
			lq_strerror());
		return 1;
	}

	O.type = LQ_qdisc;
	O.subtype = LQ_q_sfq;
	lq_set(&O);

	O.id = 0x20000;
	O.ifindex = dummy0;

	O.data.q.sfq.opt.limit = 100;
	O.data.q.sfq.opt.perturb_period = 12;

	ret = lq_do(LQ_add, &O);
	if (ret == -1) {
		printf("Error adding sfq to dummy0 [%s]:\n%s\n",
			lq_strerror(), lq_dump(&O));
		return 1;
	}

	return 0;
}
