#include <lq_com.h>


/* Functions */
/* set specific defaults */
int lq_c_set(lq *O)
{
	int	ret = 0;
 
	switch (O->subtype) {
		case LQ_c_htb:
			break;
	}

	return ret;
}

char *lq_c_dump (lq *O)
{
	static char	ret [256];

	switch (O->subtype) {
		case LQ_c_htb: {
			double	buffer, cbuffer;
			char rate[32], ceil[32], burst[32], cburst[32], mpu[32], cmpu[32];

			lq_print_rate(rate, sizeof(rate), O->data.c.htb.opt.rate.rate);
			lq_print_rate(mpu, sizeof(mpu), O->data.c.htb.opt.rate.mpu);
			buffer = ((double) O->data.c.htb.opt.rate.rate * lq_tick2usec(O->data.c.htb.opt.buffer))/1000000;
			lq_print_rate(burst, sizeof(burst), (unsigned long)buffer);

			lq_print_rate(ceil, sizeof(ceil), O->data.c.htb.opt.ceil.rate);
			lq_print_rate(cmpu, sizeof(cmpu), O->data.c.htb.opt.ceil.mpu);
			cbuffer = ((double) O->data.c.htb.opt.ceil.rate * lq_tick2usec(O->data.c.htb.opt.cbuffer))/1000000;
			lq_print_rate(cburst, sizeof(cburst), (unsigned long)cbuffer);

			snprintf (ret, sizeof(ret), "rate %s burst %s/%u mpu %s ceil %s cburst %s/%u cmpu %s\n"
				"buffer %u cbuffer %u quantum %u level %u prio %u\n"
				"lended %u borrowed %u giants %u tokens %d ctokens %d\n",
				rate, burst, 1<<O->data.c.htb.opt.rate.cell_log, mpu,
				ceil, cburst, 1<<O->data.c.htb.opt.ceil.cell_log, cmpu,
				O->data.q.htb.opt.buffer,
				O->data.q.htb.opt.cbuffer,
				O->data.q.htb.opt.quantum,
				O->data.q.htb.opt.level,
				O->data.q.htb.opt.prio,
				O->data.q.htb.xstats.lends,
				O->data.q.htb.xstats.borrows,
				O->data.q.htb.xstats.giants,
				O->data.q.htb.xstats.tokens,
				O->data.q.htb.xstats.ctokens);
			} break;

		default:
			snprintf (ret, sizeof (ret), "unknown subtype");
	}

	return ret;
}
