#include <string.h>

#include <lq_com.h>

/* Functions */
/* set specific defaults */
int lq_q_set(lq *O)
{
	int	ret = 0;

	switch (O->subtype) {
		case LQ_q_htb:
			O->data.q.htb.glob.version = 3;
			O->data.q.htb.glob.rate2quantum = 10;
		break;
	}

	return ret;
}

char *lq_q_dump (lq *O)
{
	static char	ret [1024];
	int		i;

	switch (O->subtype) {
		case LQ_q_htb:
			snprintf (ret, sizeof(ret), "version %u.%u, r2q %u default %u direct_packets_stat %u debug=%u\n",
				O->data.q.htb.glob.version >> 16, O->data.q.htb.glob.version & 0xffff,
				O->data.q.htb.glob.rate2quantum,
				O->data.q.htb.glob.defcls,
				O->data.q.htb.glob.direct_pkts,
				O->data.q.htb.glob.debug);
			break;

		case LQ_q_sfq:
			snprintf (ret, sizeof (ret), "quantum %u perturb %d limit %u divisor %u flows %u",
				O->data.q.sfq.opt.quantum,
				O->data.q.sfq.opt.perturb_period,
				O->data.q.sfq.opt.limit,
				O->data.q.sfq.opt.divisor,
				O->data.q.sfq.opt.flows);
			break;

		case LQ_q_pfifo:
			snprintf (ret, sizeof (ret), "limit %up",
				O->data.q.fifo.opt.limit);
			break;

		case LQ_q_bfifo:
			snprintf (ret, sizeof (ret), "limit %ub",
				O->data.q.fifo.opt.limit);
			break;

		case LQ_q_prio:
			snprintf (ret, sizeof (ret), "bands %d priomap [",
				O->data.q.prio.opt.bands);
			for (i = 0; i < O->data.q.prio.opt.bands; i ++) {
				char	tmp [32];

				snprintf (tmp, sizeof (tmp), " %d", O->data.q.prio.opt.priomap[i]);
				strcat (ret, tmp);
				}
			strcat (ret, "]");
			break;

		case LQ_q_dup:
			break;

		case LQ_q_ooo:
			break;

		case LQ_q_esfq:
			break;

		default:
			snprintf (ret, sizeof (ret), "unknown subtype");
	}

	return ret;
}

