#!/bin/sh

ifconfig dummy0 up
ifconfig dummy0 1.1.1.1/24

dev="dummy0"
tc qdisc del dev $dev root 2>/dev/null

echo "add qdisc root"
tc qdisc add dev $dev root handle 1: htb default 3

	echo "add class 1:1"
	tc class add dev $dev root classid 1:1 \
		htb prio 1 rate 10kbit ceil 1000kbit

		echo "add class 1:2"
		tc class add dev $dev parent 1:1 classid 1:2 \
			htb prio 2 rate 2kbit ceil 10kbit
		tc qdisc add dev $dev parent 1:2 pfifo limit 13

		echo "Add class 1:3"
		tc class add dev $dev parent 1:1 classid 1:3 \
			htb prio 3 rate 3kbit ceil 10kbit
		tc qdisc add dev $dev parent 1:3 pfifo limit 13

		for i in `seq 10 30`; do

			echo "Add class 1:${i}"
			tc class add dev $dev parent 1:1 classid 1:${i} \
				htb prio 3 rate 4kbit ceil 10kbit

			for j in `seq 5`; do
				echo "	Add class 1:${i}${j}"
				tc class add dev $dev parent 1:${i} classid 1:${i}${j} \
					htb prio 3 rate 1kbit ceil 10kbit
			done
		done


tc filter add dev $dev parent 1:0 protocol ip u32 \
	match ip dst 1.1.1.2 flowid 1:102

tc filter add dev $dev parent 1:0 protocol ip u32 \
	match ip dst 1.1.1.3 flowid 1:103

